if Fence:HasModule('Search') then return end

local L = AceLibrary("AceLocale-2.2"):new("Fence_Search")
local l = AceLibrary("AceLocale-2.2"):new("Fence")

-- Localization
L:RegisterTranslations("enUS", function() 
	return {
		["Search"] = true,
        ["Exact"] = true
	}
end)

L:RegisterTranslations("deDE", function()
	return {
		["Search"] = "Suche",
        ["Exact"] = "Exakte Suche"
	}
end)

local mod = Fence:NewModule("Search")

   function mod:OnInitialize()
      self.db = Fence:AcquireDBNamespace("Search")
      if self.db.profile.Exact == nil then self.db.profile.Exact = true end

      Fence.options.args.search = {
         type = 'group',
         name = L["Search"],
         desc = string.format(l["%s options"], L["Search"]),
         args = {
            toggle = {
               type = 'toggle',
               name = L["Search"],
               desc = string.format(l["Toggles %s function."], L["Search"]),
               get = function() return Fence:IsModuleActive('Search') end,
               set = function(v) Fence:ToggleModuleActive('Search', v) end
            },
            exact = {
               type = 'toggle',
               name = L["Exact"],
               desc = string.format(l["Toggles %s function."], L["Exact"]),
               get = function() return self.db.profile.Exact end,
               set = function(v) self.db.profile.Exact = v end
            }
         }
      }
   end


    function mod:Search(link)
		if link and not strfind(link,"item:") then return end
		BrowseMinLevel:SetText('')
		BrowseMaxLevel:SetText('')
		UIDropDownMenu_SetText('',BrowseDropDown)
		UIDropDownMenu_SetSelectedName(BrowseDropDown)
		local i,j,name = strfind(link,"%[(.+)%]")
		BrowseName:SetText(name)
		BrowseName:HighlightText(0,-1)
		IsUsableCheckButton:SetChecked(false)
		AuctionFrameBrowse.selectedSubclassIndex = nil
		AuctionFrameBrowse.selectedInvtype = nil
		AuctionFrameBrowse.selectedInvtypeIndex = nil
		AuctionFrameFilters_Update()
		BrowseSearchButton:Click()
		if not AuctionFrameBrowse:IsVisible() then AuctionFrameTab1:Click() end
	end
    
